<template>
  <v-list>
    <v-divider />
    <v-subheader>Dados Pessoais</v-subheader>
    <data-entry
      label="Nome Completo"
      :value="person.fullname"
     />    <data-entry
      label="Data de Nascimento"
      :value="ISOtoDate(person.birthDate)"
     />    <data-entry
      label="Idade"
      :value="`${ISOtoAge(person.birthDate)} anos`"
     />    <data-entry
      label="Sexo Biológico"
      :value="person.sex"
     />    <data-entry
      label="Estado Civil"
      :value="person.civilStatus"
     />    <!-- Document Section-->
    <div
      class="document-section"
      v-if="person.document"
    >
      <v-divider />
      <v-subheader>Documento</v-subheader>
      <data-entry
        :label="person.document.type"
        :value="person.document.value"
       />    </div>
    <!-- Address Section-->
    <div
      class="address-section"
      v-if="person.address"
    >
      <v-divider />
      <v-subheader>Endereço</v-subheader>
      <data-entry
        v-if="person.address.street"
        label="Rua"
        :value="person.address.street"
       />      <data-entry
        label="Número"
        :value="person.address.number"
       />      <data-entry
        v-if="person.address.cep"
        label="CEP"
        :value="person.address.cep"
       />      <data-entry
        label="Complemento"
        :value="person.address.complement"
       />    </div>
    <!-- Contact Section-->
    <div
      class="contact-section"
      v-if="person.contact"
    >
      <v-divider />
      <v-subheader>Contato</v-subheader>
      <data-entry
        label="Número de Telefone"
        :value="person.contact.phoneNumber"
       />      <data-entry
        label="Número de Emergência"
        :value="person.contact.emergencyPhoneNumber"
       />      <data-entry
        label="Contato de emergência"
        :value="person.contact.emergencyContactName"
       />    </div>
    <!-- Misc Section-->
    <v-divider />
    <v-subheader>Outros</v-subheader>
    <data-entry
      label="Meio de Divulgação"
      :value="person.marketingMedia"
     />    <data-entry
      label="Permite uso de Imagem"
      :value="person.imagePermission? 'Sim' : 'Não'"
     />    <v-textarea
      class="mx-3"
      outlined="outlined"
      label="Observações"
      v-model="observations"
     />  </v-list>
</template>

<script lang="ts">
import Vue from 'vue'

import DataEntry from '@/components/utils/DataEntry.vue'
import updatePersonMutation from '@/gql/PersonUpdate.gql'
import { ISOtoDate, ISOtoAge } from '@/util/dates'

export default Vue.extend({
  props: {
    person: {
      type: Object || null,
      default: null
    }
  },
  components: {
    DataEntry
  },
  data () {
    return {
      debounceTimer: null as NodeJS.Timeout | null
    }
  },
  computed: {
    observations: {
      async set (value) {
        this.person.observations = value

        if (this.debounceTimer) clearTimeout(this.debounceTimer)
        this.debounceTimer = setTimeout(() => {
          this.$apollo.mutate({
            mutation: updatePersonMutation,
            variables: {
              id: this.person.id,
              data: {
                observations: value
              }
            }
          })
          this.debounceTimer = null
          this.person.observations = value
        }, 3000)
      },
      get () {
        return this.person.observations
      }
    }
  },
  methods: {
    ISOtoDate,
    ISOtoAge
  }
})
</script>

<style lang="scss">
.data-entry span.value {
  cursor: pointer;
  user-select: none;
}
</style>
